unit DeepAnalysisForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Grids, BaseGrid, AdvGrid, Spin, ExtCtrls, uHelper,
  StrUtils, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  ShellAPI, IdHTTP, MSHTML, ImgList, MPlayer, AdvObj, IdIOHandler,
  IdIOHandlerSocket, IdIOHandlerStack, IdSSL, IdSSLOpenSSL, IdSSLOpenSSLHeaders;

const
  //GoogleURL = 'http://www.google.com/search?hl=en&source=hp&q=_KEYWORDS_&num=_NUM_';
//  GoogleURL = 'http://www.google.com/search?hl=en&source=hp&q=_KEYWORDS_';
  GoogleURL = 'https://www.googleapis.com/customsearch/v1?q=_KEYWORDS_&cx=_CX_' +
    '&hl=EN&lr=lang_en&key=_KEY_';
  YahooSiteLinks = 'http://siteexplorer.search.yahoo.com/search?p=_SITE_&bwm=i&bwmo=&bwmf=s';  //links to the entire site
  YahooPageLinks = 'http://siteexplorer.search.yahoo.com/search?p=_SITE_&bwm=i&bwmo=&bwmf=u';  //links to the page

type
  TfrmDeepAnalysis = class(TForm)
    pnlMain: TPanel;
    pnlResults: TPanel;
    barProgress: TProgressBar;
    Panel1: TPanel;
    StaticText2: TStaticText;
    barStatus: TStatusBar;
    Timer1: TTimer;
    pnlSettings: TPanel;
    pnlSettingsTitle: TPanel;
    StaticText1: TStaticText;
    Memo1: TMemo;
    bStart: TButton;
    bStop: TButton;
    Keywords: TLabel;
    Label1: TLabel;
    ComboBox1: TComboBox;
    CheckBox1: TCheckBox;
    Panel3: TPanel;
    TBXButton2: TButton;
    TBXButton3: TButton;
    TBXButton4: TButton;
    dlgS: TSaveDialog;
    dlgO: TOpenDialog;
    Timer2: TTimer;
    IdTCPClient1: TIdTCPClient;
    TBXButton5: TButton;
    CheckBox2: TCheckBox;
    ImageList1: TImageList;
    gRes: TAdvStringGrid;
    Panel2: TPanel;
    procedure btnStartClick(Sender: TObject);
    procedure TBXButton3Click(Sender: TObject);
    procedure TBXButton4Click(Sender: TObject);
    procedure bStopClick(Sender: TObject);
    procedure HandleWorkerFinished(Sender: TObject);
    procedure TBXButton2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure TBXButton5Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    FWorker: TThread;
    FSource: String;
    FSearch: String;
  public
    procedure ClearGrid;
  end;

var
  frmDeepAnalysis: TfrmDeepAnalysis;

implementation

uses
  uGooglePageRank, FastStrings, FastStringFuncs, MainForm;


{.$R PDF.RES}


procedure SaveS(var s: AnsiString; FFileName: String);
var
  sl: TStringList;
begin
  sl := TStringList.Create;
  try
    sl.Text := s;
    sl.SaveToFile(FFileName);
  finally
    sl.Free;
  end;
end;

function stoi(s: AnsiString): Integer;
var
  i: Integer;
begin
  for i := 32 to 255 do
  begin
    if (not(Char(i) in ['0'..'9']))and(Pos(Char(Byte(i)), s) > 0) then
      s := StringReplace(s, Char(Byte(i)), '', [rfReplaceAll]);
  end;
  Result := StrToIntDef(s,-1);
end;

procedure GetHTMLSource(AURL: AnsiString; AProxy: AnsiString;
  APort: Integer; ConnectTimeout, ReadTimeout: Integer;
  var ASource: AnsiString);
var
  MemStream: TMemoryStream;
  StrList: TStrings;
  IdHTTP: TIdHTTP;
begin
  ASource := '';
  IdHTTP := TIdHTTP.Create(nil);
  IdHTTP.AllowCookies := True;
  with IdHTTP do
  begin
    Response.KeepAlive := true;
    HandleRedirects := true;
//    IdHTTP.IOHandler := frmDeepAnalysis.IdSSLIOHandlerSocketOpenSSL1;
    Request.UserAgent := 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0; priustest; .NET CLR 1.1.4322; .NET CLR 2.0.50727; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729; priustest; InfoPath.1)';
  end;
  MemStream := TMemoryStream.Create;
  {if AProxy = '' then
  begin
    HTMLGetCS.Acquire;
    while Abs(GetTickCount - HTMLGetLastGet) < HTMLGetDelayInMS  do
      Sleep(200);
    HTMLGetLastGet := GetTickCount;
  end;}
  try
    if AProxy <> '' then
    begin
      IdHTTP.ProxyParams.ProxyServer := AProxy;
      IdHTTP.ProxyParams.ProxyPort := APort;
    end;
    IdHTTP.ConnectTimeout := ConnectTimeout;
    IdHTTP.ReadTimeout := ReadTimeout;
    IdHTTP.Get(aURL, MemStream);
    MemStream.Position := 0;
    StrList := TStringList.Create;
    try
      StrList.LoadFromStream(MemStream);
      ASource := StrList.Text;
    finally
      StrList.Free;
    end;
  finally
    {if AProxy = '' then
      HTMLGetCS.Release;}
    MemStream.Free;
    IdHTTP.Free;
  end;
end;

function PageRank(url: AnsiString): AnsiString;
var
  s: AnsiString;
begin
  s := 'http://toolbarqueries.google.com' + uGooglePageRank.TPageRankCalc.SearchURI(url);
  s := Trim(DownloadFile3(s));
  while (Pos(':', s) > 0) do
  begin
    Delete(s, 1, Pos(':', s));
  end;
  Result := Trim(s);
  if (Trim(Result) = '')  then Result := '0'; // if we didn't get any PR, return it as PR 0
  if (Length(Result) > 2) then Result := '0'; // if we got more than 2 chars for the PR, return it as PR 0; most likely we got an error message from Google
end;

function HTMLDecode(const AStr: String): String;
var
  Sp, Rp, Cp, Tp: PChar;
  S: String;
  I, Code: Integer;
begin
  SetLength(Result, Length(AStr));
  Sp := PChar(AStr);
  Rp := PChar(Result);
  Cp := Sp;
  try
    while Sp^ <> #0 do
    begin
      case Sp^ of
        '&': begin
               Cp := Sp;
               Inc(Sp);
               case Sp^ of
                 'a': if AnsiStrPos(Sp, 'amp;') = Sp then  { do not localize }
                      begin
                        Inc(Sp, 3);
                        Rp^ := '&';
                      end;
                 'l',
                 'g': if (AnsiStrPos(Sp, 'lt;') = Sp) or (AnsiStrPos(Sp, 'gt;') = Sp) then { do not localize }
                      begin
                        Cp := Sp;
                        Inc(Sp, 2);
                        while (Sp^ <> ';') and (Sp^ <> #0) do
                          Inc(Sp);
                        if Cp^ = 'l' then
                          Rp^ := '<'
                        else
                          Rp^ := '>';
                      end;
                 'n': if AnsiStrPos(Sp, 'nbsp;') = Sp then  { do not localize }
                      begin
                        Inc(Sp, 4);
                        Rp^ := ' ';
                      end;
                 'q': if AnsiStrPos(Sp, 'quot;') = Sp then  { do not localize }
                      begin
                        Inc(Sp,4);
                        Rp^ := '"';
                      end;
                 '#': begin
                        Tp := Sp;
                        Inc(Tp);
                        while (Sp^ <> ';') and (Sp^ <> #0) do
                          Inc(Sp);
                        SetString(S, Tp, Sp - Tp);
                        Val(S, I, Code);
                        Rp^ := Chr((I));
                      end;
                 else
                   Exit;
               end;
           end
      else
        Rp^ := Sp^;
      end;
      Inc(Rp);
      Inc(Sp);
    end;
  except
  end;
  SetLength(Result, Rp - PChar(Result));
end;


//
//  Returns the path to the folder where the EXE is located
//
function AppPath: String;
begin
  Result := ExtractFilePath(Application.ExeName);
  if Result[Length(Result)] <> '\' then
    Result := Result + '\';
end;

//  Gets the temporary folder
function GetTempFolder: string;
var
  aPath: array [0..MAX_PATH] of char;
begin
  Win32Check(GetTempPath(MAX_PATH, aPath) <> 0);
  Result := aPath;
end;

var
  FmtSettings: TFormatSettings;

type

  TAnalyzeThread = class(TThread)
  protected
    FRow: Integer;
    FCol: Integer;
    FText: String;
    FRowCells: TStringList;
    FRowCount: Integer;
    FURL: String;
    FSource: String;
    FSearch: String;
    FProgress: Integer;
    procedure EditCell;
    procedure AddRow;
    procedure GetRow;
    procedure GetRowCount;
    procedure UpdateProgressBar;
    procedure Execute; override;
  public
    Keywords: TStringList;
    Num: AnsiString;
    Abort: Integer;
    Done: Boolean;
    constructor Create;
    destructor Destroy; override;
  end;

{ TAnalyzeThread }

procedure TAnalyzeThread.AddRow;
var
  r,i,j,space: Integer;
begin
  with frmDeepAnalysis do
  begin
    gRes.AddRow;
    r := gRes.RowCount-1;
    gRes.Cells[0, r] := FRowCells[0];
    gRes.Cells[1, r] := FRowCells[1];
    gRes.Cells[2, r] := FRowCells[2];
    gRes.Cells[3, r] := FRowCells[3];
//    gRes.Cells[4, r] := FRowCells[4];
//    gRes.Cells[5, r] := FRowCells[5];


    if frmDeepAnalysis.CheckBox2.Checked then
    begin
      frmDeepAnalysis.gRes.SizeGrowOnly := True;
      frmDeepAnalysis.gRes.AutoSizeCol(1);
      frmDeepAnalysis.gRes.AutoSizeCol(2);
      space := gRes.Width-22;
      j := 0;
      for i := 0 to gRes.ColCount-1 do
        j := j + gRes.ColWidths[i];
      if j > space then
      begin
        i := (j-space) div 2;
        //gRes.ColWidths[1] := gRes.ColWidths[1] - i;
        gRes.ColWidths[2] := gRes.ColWidths[2] - 2*i;
      end;
    end;
  end;
end;

constructor TAnalyzeThread.Create;
begin
  inherited Create(True);
  Keywords := TStringList.Create;
  FRowCells := TStringList.Create;
  Done := False;
  Abort := 0;
end;

destructor TAnalyzeThread.Destroy;
begin
  Keywords.Free;
  FRowCells.Free;
  inherited;
end;

procedure TAnalyzeThread.EditCell;
begin
  with frmDeepAnalysis do
  begin
    gRes.Cells[FCol, FRow] := FText;
  end;
end;

procedure TAnalyzeThread.Execute;

  function Number(s: String): Integer;
  var
    i: Integer;
  begin
    s := StringReplace(Trim(s), ',', '', [rfIgnoreCase, rfReplaceAll]);
    for i := 1 to Length(s) do
      if not (s[i] in ['0','1'..'9']) then
        s[i] := ',';
    Val(s,Result,i);
    if i <> 0 then
      Result := 0;
  end;

  function StripHTML(S: string): string;
  var
    TagBegin, TagEnd, TagLength: integer;
  begin
    TagBegin := Pos( '<', S);      // search position of first <
    while (TagBegin > 0) do begin  // while there is a < in S
      TagEnd := Pos('>', S);              // find the matching >
      TagLength := TagEnd - TagBegin + 1;
      Delete(S, TagBegin, TagLength);     // delete the tag
      TagBegin:= Pos( '<', S);            // search for next <
    end;
    Result := S;                   // give the result
  end;

var
  i, j, k, cnt, offset, iStart, iEnd, ave_cnt3, ave_sum3, ave_cnt4, ave_sum4, ave_cnt5, ave_sum5: Integer;
  s, s1, s2, url, link, title, inlinks, rank: String;
  Doc: IHTMLDocument2;
  StartingFrom: Integer;
  MessageText: String;
begin

  inherited;

  Synchronize(GetRowCount);
  StartingFrom := FRowCount;

  for i := 0 to Keywords.Count - 1 do
  begin

//    url := StringReplace(GoogleUrl, '_NUM_', Num, [rfIgnoreCase, rfReplaceAll]);
    url := StringReplace(GoogleUrl, '_CX_', Trim(frm.CustomSearchEngineCode), [rfIgnoreCase, rfReplaceAll]);
    url := StringReplace(Url, '_KEY_', Trim(frm.APIKey), [rfIgnoreCase, rfReplaceAll]);
    url := StringReplace(Url, '_KEYWORDS_', StringReplace(Keywords[i], ' ', '+', [rfIgnoreCase, rfReplaceAll]), [rfIgnoreCase, rfReplaceAll]);
    try
//      GetHTMLSource(url, '', 0, 5000, 5000, s);
      s := DownloadFile3(url);
      //Sleep(3000);
    except
    end;

//    SaveS(s,'c:\sa.html');


{    ExtractParagraph(s, s1, 'id=resultStats>', '<');
    s2 := Copy(s1, 16, Length(s1) - 16);
    s2 := StringReplace(s2, 'About ', '', [rfReplaceAll]);
    s2 := StringReplace(s2, ' results', '', [rfReplaceAll]);
    ExtractParagraph(s, s1, 'id="res"', '</ol>'); }
    if not ExtractParagraphJSON(s, s2, '"totalResults": "', '"') then
    begin
      offset := 1;
      MessageText := 'Abnormal request terminatiom. ';
      if ExtractSParagraphJSON(s, s1, '"message": "', '"',offset) then
        MessageText := MessageText + s1;
      if i <> (Keywords.Count-1) then
        if MessageDlg(MessageText + #13#10#13#10 + 'Do you wish to continue request?',
        mtConfirmation,[mbYes,mbNo],0,mbYes)=mrYes then
          continue
        else
          exit
      else
      begin
        ShowMessage(MessageText);
        exit;
      end;
    end;

//    if (s = '')or(s1 = '') then
//      Continue;

    FRowCells.Clear;
    FRowCells.Add('');
    FRowCells.Add('<b>' + Keywords[i] + '</b>');
    FRowCells.Add('<b>' + s2 + '</b>');
    FRowCells.Add('');
//    FRowCells.Add('');
//    FRowCells.Add('');
    Synchronize(AddRow);

    // Star iterate trough search results
    offset := 1;
    cnt := 1;
//    iStart := SmartPos('<li ', s1, false, offset);
//    if iStart > 0 then
//      offset := iStart + Length('<li class=');
    iStart :=  PosEx('"items":',s,offset);
    if iStart <= 0 then
    begin
      ShowMessage('Empty request result');
      continue;
    end;
    offset := iStart + 8;
    repeat
      ExtractSParagraphJSON(s, title, '"title": "', '"',offset);
      ExtractSParagraphJSON(s, link, '"link": "', '"',offset);
{
        iStart :=  PosEx(' "title": "',s,offset);
        iEnd := SmartPos('<li ', s1, false, offset);
        if iEnd > 0 then
        begin
          s2 := Copy(s1, iStart, iEnd - iStart);
          iStart := iEnd;
          offset := iStart + Length('<li class=');
        end
        else
          s2 := Copy(s1, iStart, MaxInt);
        try
          ExtractParagraph2(s2, link, ' href="', '"');
          ExtractParagraph2(s2, title, '>', '</a></h3>');
          if LowerCase(Copy(link, 1, 4)) <> 'http' then
            Continue;
          if Pos('//webcache.googleusercontent.com/', LowerCase(link)) > 0 then
            Continue;


          title := StripHTML(title);
}
          link := HTMLDecode(link);

          FRowCells.Clear;
          FRowCells.Add(IntToStr(cnt));
          FRowCells.Add(title);
          FRowCells.Add(link);

{          rank := PageRank(link);
          FRowCells.Add(rank);
}
          FRowCells.Add('');
          Synchronize(AddRow);
{        except
        end;
}
        Inc(cnt);
        //if DoStop then
        // goto TheEnd; //  The stop condition was met.
//      until (iEnd = 0)or(cnt=11);
    until cnt >= 11;

    FRowCells.Clear;
    FRowCells.Add('');
    FRowCells.Add('');
    FRowCells.Add('<b>Averages:</b>');
    FRowCells.Add('');
    Synchronize(AddRow);

    FRowCells.Clear;
    FRowCells.Add('');
    FRowCells.Add('');
    FRowCells.Add('');
    FRowCells.Add('');
    Synchronize(AddRow);

    FProgress := Round(20 * ((i+1)/(Keywords.Count+1)));
    Synchronize(UpdateProgressBar);
    if Abort <> 0 then
      Exit;
    // Goto Next Line of Keywords
    Sleep(500); // Not to overflow the WEB portal.

  end;

  Synchronize(GetRowCount);

  ave_cnt3 := 0;
  ave_sum3 := 0;
  ave_cnt4 := 0;
  ave_sum4 := 0;
  ave_cnt5 := 0;
  ave_sum5 := 0;

  for i := StartingFrom+1 to FRowCount - 1 do
  begin

    FRow := i;
    Synchronize(GetRow);
    if (FRowCells.Count < 4) then
      Continue;
    link := FRowCells[2];
    if (link = '<b>Averages:</b>') then
    begin
      if (ave_cnt3 = 0) then
        ave_sum3 := 0
      else
      begin
        FCol := 3;
        FText := '<b>' + FormatFloat('#,###', Round(ave_sum3/ave_cnt3), FmtSettings) + '</b>';
        Synchronize(EditCell);
        ave_cnt3 := 0;
        ave_sum3 := 0;
      end;
{
      if (ave_cnt4 = 0) then
        ave_sum4 := 0
      else
      begin
        FCol := 5;
        FText := '<b>' + FormatFloat('#,###', Round(ave_sum4/ave_cnt4), FmtSettings) + '</b>';
        Synchronize(EditCell);
        ave_cnt4 := 0;
        ave_sum4 := 0;
      end;

      if (ave_cnt5 = 0) then
        ave_sum5 := 0
      else
      begin
        FCol := 3;
        FText := '<b>' {+ IntToStr(ave_sum5) + '/' + IntToStr(ave_cnt5) + '='} {+ IntToStr(Round(ave_sum5/ave_cnt5)) + '</b>';
        Synchronize(EditCell);
        ave_cnt5 := 0;
        ave_sum5 := 0;
      end;
}
      Continue;
    end;
    if (link = '') or (LeftStr(link,3)= '<b>') then
      Continue;
{  // Rank
    if StrToIntDef(FRowCells[3],-1) >= 0 then
    begin
      Inc(ave_cnt5);
      Inc(ave_sum5, StrToIntDef(FRowCells[3], 0));
    end;
}
    //if (Lowercase(Copy(link,1,4)) <> 'http') then
    //  Continue;

{    link := StringReplace(link,'http://','',[rfIgnoreCase]);
    link := StringReplace(link,'https://','',[rfIgnoreCase]);
    url := StringReplace(GoogleUrl, '_NUM_', Num, [rfIgnoreCase, rfReplaceAll]);
    url := StringReplace(GoogleUrl, '_KEYWORDS_', 'link:' + UrlEncodeRFC3986(link), [rfIgnoreCase, rfReplaceAll]);
}
    url := StringReplace(GoogleUrl, '_CX_', Trim(frm.CustomSearchEngineCode), [rfIgnoreCase, rfReplaceAll]);
    url := StringReplace(Url, '_KEY_', Trim(frm.APIKey), [rfIgnoreCase, rfReplaceAll]);
    url := StringReplace(Url, '_KEYWORDS_', 'link%3A+' + UrlEncodeRFC3986(link), [rfIgnoreCase, rfReplaceAll]);

    try
      s := DownloadFile3(url);// GetHTMLSource(url, '', 0, 5000, 5000, s);
//        SaveS(s,'c:\sa1_' + IntToStr(i) + '.html');
      //Sleep(3000);
    except
    end;
{
    ExtractParagraph(s, s1, 'id="resultStats">', '<');
    s2 := Copy(s1, 18, Length(s1) - 18);
    s2 := StringReplace(s2, 'About ', '', [rfReplaceAll]);
    s2 := StringReplace(s2, ' results', '', [rfReplaceAll]);
    s2 := StringReplace(s2, ' result', '', [rfReplaceAll]);
}
    if not ExtractParagraphJSON(s, s2, '"totalResults": "', '"') then
    begin
      offset := 1;
      MessageText := 'Abnormal request terminatiom. ';
      if ExtractSParagraphJSON(s, s1, '"message": "', '"',offset) then
        MessageText := MessageText + s1;
      if i <> (Keywords.Count-1) then
        if MessageDlg(MessageText + #13#10#13#10 + 'Do you wish to continue request?',
        mtConfirmation,[mbYes,mbNo],0,mbYes)=mrYes then
          continue
        else
          exit
      else
      begin
        ShowMessage(MessageText);
        exit;
      end;
    end;

    inlinks := s2;
    if inlinks <> '' then
    begin
      FCol := 3;
      FText := inlinks;
      Synchronize(EditCell);
      j := number(inlinks);
      if j >= 0 then
      begin
        ave_sum3 := ave_sum3 + j;
        Inc(ave_cnt3);
      end;
    end
    else
    begin
      FCol := 3;
      FText := '0';
      Synchronize(EditCell);
      Inc(ave_cnt3);
    end;

    {url := StringReplace(YahooSiteLinks, '_SITE_', UrlEncodeRFC3986(link), [rfIgnoreCase, rfReplaceAll]);
    s := DownloadFile4(url, 20000);
    ExtractParagraph(s, s1, '<ul id="result-details">', '</ul>');
    ExtractParagraph2(s1, inlinks, 'Inlinks (', ')');
    if inlinks <> '' then
    begin
      FCol := 5;
      FText := inlinks;
      Synchronize(EditCell);
      j := number(inlinks);
      if j >= 0 then
      begin
        ave_sum4 := ave_sum4 + j;
        Inc(ave_cnt4);
      end;
    end;}

    FProgress := 20 + Round(80 * ((i+1-StartingFrom)/(FRowCount+1-StartingFrom)));
    Synchronize(UpdateProgressBar);
    if Abort <> 0 then
      Exit;

  end;
  

end;

procedure TAnalyzeThread.GetRow;
begin
  FRowCells.Clear;
  FRowCells.Add(frmDeepAnalysis.gRes.Cells[0, FRow]);
  FRowCells.Add(frmDeepAnalysis.gRes.Cells[1, FRow]);
  FRowCells.Add(frmDeepAnalysis.gRes.Cells[2, FRow]);
  FRowCells.Add(frmDeepAnalysis.gRes.Cells[3, FRow]);
//  FRowCells.Add(frmDeepAnalysis.gRes.Cells[4, FRow]);
end;

procedure TAnalyzeThread.GetRowCount;
begin
  FRowCount := frmDeepAnalysis.gRes.RowCount;
end;

procedure TAnalyzeThread.UpdateProgressBar;
begin
  frmDeepAnalysis.barProgress.Position := FProgress;
end;

{$R *.dfm}

procedure TfrmDeepAnalysis.btnStartClick(Sender: TObject);
var
  s: String;
begin
  if (Assigned(FWorker))and(not TAnalyzeThread(FWorker).Done) then
  begin
    MessageDlg('The analyzing is in progress. It must be finished first.', mtInformation, [mbOK], 0);
    Exit;
  end;
  if Trim(Memo1.Lines.Text) = '' then
  begin
    MessageDlg('Please type in some keyword phrases before search (one per line).', mtInformation, [mbOK], 0);
    Exit;
  end;
  if not CheckBox1.Checked then
  begin
    //  clear the grid
    gRes.RowCount := 2;
    gRes.Cells[0, 1] := '';
    gRes.Cells[1, 1] := '';
    gRes.Cells[2, 1] := '';
    gRes.Cells[3, 1] := '';
//    gRes.Cells[4, 1] := '';
    gRes.ColWidths[1] := 160;
    gRes.ColWidths[2] := 160;
  end;
  if Assigned(FWorker) then
    FreeAndNil(FWorker);
  FWorker := TAnalyzeThread.Create;
  TAnalyzeThread(FWorker).Keywords.Assign(Memo1.Lines);
  TAnalyzeThread(FWorker).Num := ComboBox1.Text;
  TAnalyzeThread(FWorker).Done := False;
  TAnalyzeThread(FWorker).OnTerminate := HandleWorkerFinished;
  FWorker.Suspended := False;
  Memo1.ReadOnly := True;
  Memo1.Color := clMoneyGreen;
  barProgress.Position := 0;
end;

procedure TfrmDeepAnalysis.TBXButton3Click(Sender: TObject);
begin
  gRes.SaveWithHTML := False;
  if (Assigned(FWorker))and(not TAnalyzeThread(FWorker).Done) then
  begin
    MessageDlg('The analyzing is in progress. It must be finished first.', mtInformation, [mbOK], 0);
    Exit;
  end;
  if dlgS.Execute then
  begin
    if FileExists(dlgS.FileName) then
    begin
      if MessageDlg('The file you specified exists. Do you want to overwrite it?', mtConfirmation, [mbYes, mbCancel], 0) = ID_YES then
        gRes.SaveToCSV(dlgS.FileName);
    end
    else
      gRes.SaveToCSV(dlgS.FileName);
  end;
end;

procedure TfrmDeepAnalysis.TBXButton4Click(Sender: TObject);
var
  i: Integer;
begin
  if (Assigned(FWorker))and(not TAnalyzeThread(FWorker).Done) then
  begin
    MessageDlg('The analyzing is in progress. It must be finished first.', mtInformation, [mbOK], 0);
    Exit;
  end;
  if dlgO.Execute then
  try
    //  clear the grid
    gRes.RowCount := 2;
    gRes.Cells[0, 1] := '';
    gRes.Cells[1, 1] := '';
    gRes.Cells[2, 1] := '';
    gRes.Cells[3, 1] := '';
//    gRes.Cells[4, 1] := '';
    gRes.ColWidths[1] := 160;
    gRes.ColWidths[2] := 160;
    //
    gRes.LoadFromCSV(dlgO.FileName);
    for i := 1 to gRes.RowCount-1 do
    begin
      if Trim(gRes.Cells[0,i]) = '' then
      begin
        if Pos('results',gRes.Cells[2,i])>0 then
        begin
          gRes.Cells[1,i] := '<b>'+gRes.Cells[1,i]+'</b>';
          gRes.Cells[2,i] := '<b>'+gRes.Cells[2,i]+'</b>';
        end;
        if Pos('Averages:',gRes.Cells[2,i])>0 then
        begin
          gRes.Cells[2,i] := '<b>'+gRes.Cells[2,i]+'</b>';
          if trim(gRes.Cells[3,i]) <> '' then
            gRes.Cells[3,i] := '<b>'+gRes.Cells[3,i]+'</b>';
//          if trim(gRes.Cells[4,i]) <> '' then
//            gRes.Cells[4,i] := '<b>'+gRes.Cells[4,i]+'</b>';
        end;
      end;
    end;
    CheckBox2Click(nil);
  except
  end;
end;

procedure TfrmDeepAnalysis.bStopClick(Sender: TObject);
begin
 if Assigned(FWorker) then
   TAnalyzeThread(FWorker).Abort := 1;
end;

procedure TfrmDeepAnalysis.HandleWorkerFinished(Sender: TObject);
begin
  TAnalyzeThread(FWorker).Done := True;
  Memo1.ReadOnly := False;
  Memo1.Color := clWindow;
  barProgress.Position := 0;
  if FileExists(GetTempFolder + 'chimes.wav') then
  begin
    frm.MediaPlayer1.FileName := GetTempFolder + 'chimes.wav';
    frm.MediaPlayer1.Open;
    frm.MediaPlayer1.Play;
  end;
end;

procedure TfrmDeepAnalysis.TBXButton2Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmDeepAnalysis.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if (Assigned(FWorker))and(not TAnalyzeThread(FWorker).Done) then
  begin
    MessageDlg('The analyzing is in progress. It must be finished first.', mtInformation, [mbOK], 0);
    CanClose := False;
  end;
end;

procedure TfrmDeepAnalysis.TBXButton5Click(Sender: TObject);
var
  s: AnsiString;
  stream: TResourceStream;
begin
{  s := GetTempFolder + 'Simple SEO Tactics.pdf';
  stream := TResourceStream.Create(HInstance, PChar('pdf'), PChar('DATA'));
  stream.SaveToFile(s);
  ShellExecute(0, PChar('open'), PChar(s), nil, nil, SW_SHOW);  }
  ShellExecute(0, PChar('open'), PChar('http://www.backlinksninja.com/2000-bonus-backlinks.php'), nil, nil, SW_SHOW);
end;

procedure TfrmDeepAnalysis.Timer1Timer(Sender: TObject);
begin
  //Panel2.Visible := (Assigned(FWorker))and(not TAnalyzeThread(FWorker).Done);
end;

procedure TfrmDeepAnalysis.CheckBox2Click(Sender: TObject);
var
  i, j, space: Integer;
begin
  if (CheckBox2.Checked)and(gRes.RowCount > 2) then
  begin
    frmDeepAnalysis.gRes.SizeGrowOnly := True;
    frmDeepAnalysis.gRes.AutoSizeCol(1);
    frmDeepAnalysis.gRes.AutoSizeCol(2);
    space := gRes.Width-24;
    j := 0;
    for i := 0 to gRes.ColCount-1 do
      j := j + gRes.ColWidths[i];
    if j > space then
    begin
      i := (j-space) div 2;
      //gRes.ColWidths[1] := gRes.ColWidths[1] - i;
      gRes.ColWidths[2] := gRes.ColWidths[2] - 2*i;
    end;
  end;
end;

procedure TfrmDeepAnalysis.ClearGrid;
begin
    //  clear the grid
    gRes.RowCount := 2;
    gRes.Cells[0, 1] := '';
    gRes.Cells[1, 1] := '';
    gRes.Cells[2, 1] := '';
    gRes.Cells[3, 1] := '';
//    gRes.Cells[4, 1] := '';
    gRes.ColWidths[1] := 160;
    gRes.ColWidths[2] := 160;
end;

procedure TfrmDeepAnalysis.FormCreate(Sender: TObject);
//var
//  t: TDateTime;
begin
  //t := Now;
  //if t > 40570 then
  //  Application.Terminate;
end;

initialization

  FmtSettings.DecimalSeparator := '.';
  FmtSettings.ThousandSeparator := ',';

end.
