unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Grids, BaseGrid, AdvGrid, Spin, ExtCtrls, uHelper,
  StrUtils, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  ShellAPI, IdHTTP, MSHTML, ImgList, MPlayer, AdvObj, Registry;

const
  //GoogleURL = 'http://www.google.com/search?hl=en&source=hp&q=_KEYWORDS_&num=_NUM_';
  GoogleURL1 = 'http://www.google.com/search?hl=en&source=hp&q=_KEYWORDS_';
//  GoogleURL = 'https://www.google.com.ua/search?client=opera&q=_KEYWORDS_&sourceid=opera&ie=&oe=&hl=EN&pws=1';
  GoogleURL = 'https://www.googleapis.com/customsearch/v1?q=_KEYWORDS_&cx=_CX_' +
    '&hl=EN&lr=lang_en&key=_KEY_';

  YahooSiteLinks = 'http://siteexplorer.search.yahoo.com/search?p=_SITE_&bwm=i&bwmo=&bwmf=s';  //links to the entire site
  YahooPageLinks = 'http://siteexplorer.search.yahoo.com/search?p=_SITE_&bwm=i&bwmo=&bwmf=u';  //links to the page

type
  Tfrm = class(TForm)
    pnlMain: TPanel;
    pnlResults: TPanel;
    barProgress: TProgressBar;
    Panel1: TPanel;
    StaticText2: TStaticText;
    barStatus: TStatusBar;
    Timer1: TTimer;
    pnlSettings: TPanel;
    pnlSettingsTitle: TPanel;
    StaticText1: TStaticText;
    Memo1: TMemo;
    bStart: TButton;
    bStop: TButton;
    Keywords: TLabel;
    Label1: TLabel;
    ComboBox1: TComboBox;
    CheckBox1: TCheckBox;
    Panel3: TPanel;
    TBXButton2: TButton;
    TBXButton1: TButton;
    dlgS: TSaveDialog;
    dlgO: TOpenDialog;
    Timer2: TTimer;
    IdTCPClient1: TIdTCPClient;
    TBXButton5: TButton;
    CheckBox2: TCheckBox;
    ImageList1: TImageList;
    gRes: TAdvStringGrid;
    Edit1: TEdit;
    Button3: TButton;
    bExport: TButton;
    bClearAll: TButton;
    bClear: TButton;
    bOpen: TButton;
    bSave: TButton;
    dlgS2: TSaveDialog;
    Panel2: TPanel;
    MediaPlayer1: TMediaPlayer;
    btSettings: TButton;
    procedure btnStartClick(Sender: TObject);
    procedure TBXButton3Click(Sender: TObject);
    procedure TBXButton4Click(Sender: TObject);
    procedure bStopClick(Sender: TObject);
    procedure HandleWorkerFinished(Sender: TObject);
    procedure TBXButton2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure TBXButton1Click(Sender: TObject);
    procedure TBXButton5Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure gResGetCellColor(Sender: TObject; ARow, ACol: Integer;
      AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
    procedure bSaveClick(Sender: TObject);
    procedure bOpenClick(Sender: TObject);
    procedure bClearClick(Sender: TObject);
    procedure bClearAllClick(Sender: TObject);
    procedure bExportClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure btSettingsClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    FWorker: TThread;
    FSource: String;
    FSearch: String;
    Saving: Boolean;
    function WorkersWorking(ARaiseAlarm: Boolean): Boolean;
  public
    { Public declarations }
    APIKey: String;
    CustomSearchEngineCode: String;
    CloseForm: Boolean;
  end;

var
  frm: Tfrm;

implementation

uses
  uGooglePageRank, FastStrings, FastStringFuncs, DeepAnalysisForm, uSettings;

  var
    fdelay: Integer = 10000;

{$R PDF.RES}

{$R chimes.wav.RES}

//  Gets the temporary folder
function GetTempFolder: string;
var
  aPath: array [0..MAX_PATH] of char;
begin
  Win32Check(GetTempPath(MAX_PATH, aPath) <> 0);
  Result := aPath;
end;

procedure SaveS(var s: AnsiString; FFileName: String);
var
  sl: TStringList;
begin
  sl := TStringList.Create;
  try
    sl.Text := s;
//    sl.SaveToFile('c:\s.html');
    sl.SaveToFile(FFileName);
  finally
    sl.Free;
  end;
end;

function stoi(s: AnsiString): Int64;
var
  i: Integer;
begin
  for i := 32 to 255 do
  begin
    if (not(Char(i) in ['0'..'9']))and(Pos(Char(Byte(i)), s) > 0) then
      s := StringReplace(s, Char(Byte(i)), '', [rfReplaceAll]);
  end;
  Result := StrToInt64Def(s,-1);
end;

procedure GetHTMLSource(AURL: AnsiString; AProxy: AnsiString;
  APort: Integer; ConnectTimeout, ReadTimeout: Integer;
  var ASource: AnsiString);
var
  MemStream: TMemoryStream;
  StrList: TStrings;
  IdHTTP: TIdHTTP;
begin
  ASource := '';
  IdHTTP := TIdHTTP.Create(nil);
  //IdHTTP.AllowCookies := True;
  with IdHTTP do
  begin
   // Response.KeepAlive := true;
   // HandleRedirects := true;
    Request.UserAgent := 'Mozilla/5.0 (Windows; U; Windows NT 6.0; en-US; rv:1.9.2.24) Gecko/20111103 Firefox/3.6.24 ( .NET CLR 3.5.30729; .NET4.0C)';
  end;
  MemStream := TMemoryStream.Create;
  {if AProxy = '' then
  begin
    HTMLGetCS.Acquire;
    while Abs(GetTickCount - HTMLGetLastGet) < HTMLGetDelayInMS  do
      Sleep(200);
    HTMLGetLastGet := GetTickCount;
  end;}
  try
    if AProxy <> '' then
    begin
      IdHTTP.ProxyParams.ProxyServer := AProxy;
      IdHTTP.ProxyParams.ProxyPort := APort;
    end;
    IdHTTP.ConnectTimeout := ConnectTimeout;
    IdHTTP.ReadTimeout := ReadTimeout;
    IdHTTP.Get(aURL, MemStream);
    MemStream.Position := 0;
    StrList := TStringList.Create;
    try
      StrList.LoadFromStream(MemStream);
      ASource := StrList.Text;
    finally
      StrList.Free;
    end;
  finally
    {if AProxy = '' then
      HTMLGetCS.Release;}
    MemStream.Free;
    IdHTTP.Free;
  end;
end;

function PageRank(url: AnsiString): AnsiString;
var
  s: AnsiString;
begin
  s := 'http://toolbarqueries.google.com' + uGooglePageRank.TPageRankCalc.SearchURI(url);
  s := Trim(DownloadFile3(s));
  while (Pos(':', s) > 0) do
  begin
    Delete(s, 1, Pos(':', s));
  end;
  Result := Trim(s);
  if (Trim(Result) = '')  then Result := '0'; // if we didn't get any PR, return it as PR 0
  if (Length(Result) > 2) then Result := '0'; // if we got more than 2 chars for the PR, return it as PR 0; most likely we got an error message from Google
end;

//
//  Returns the path to the folder where the EXE is located
//
function AppPath: String;
begin
  Result := ExtractFilePath(Application.ExeName);
  if Result[Length(Result)] <> '\' then
    Result := Result + '\';
end;

var
  FmtSettings: TFormatSettings;

type

  TAnalyzeThread = class(TThread)
  protected
    FRow: Integer;
    FCol: Integer;
    FText: String;
    FRowCells: TStringList;
    FRowCount: Integer;
    FURL: String;
    FSource: String;
    FSearch: String;
    FProgress: Integer;
    procedure EditCell;
    procedure AddRowA;
    procedure GetRow;
    procedure GetRowCount;
    procedure UpdateProgressBar;
    procedure Execute; override;
  public
    Keywords: TStringList;
    Num: AnsiString;
    Abort: Integer;
    Done: Boolean;
    ColNum: Integer;
    procedure EditCol;
    constructor Create;
    destructor Destroy; override;
  end;

{ TAnalyzeThread }

procedure TAnalyzeThread.AddRowA;
var
  r,i,j,space: Integer;
begin
  with frm do
  begin
    if (gRes.RowCount = 2)and(gRes.Cells[1,1]= '')and(gRes.Cells[1,2] = '') then
    begin
      r := 1;
    end
    else
    begin
      gRes.AddRow;
      r := gRes.RowCount-1;
    end;
    gRes.AddCheckBox(0, r, True, False);
    gRes.Cells[0, r] := FRowCells[0];
    gRes.Cells[1, r] := FRowCells[1];
    gRes.Cells[2, r] := FRowCells[2];
    gRes.Cells[3, r] := FRowCells[3];
    gRes.Cells[4, r] := FRowCells[4];
  end;
end;

procedure TAnalyzeThread.EditCol;
var
  r: Integer;
begin
  with frm do
  begin
    r := gRes.RowCount-1;
    gRes.Cells[ColNum, r] := FRowCells[0];
  end;
end;

constructor TAnalyzeThread.Create;
begin
  inherited Create(True);
  Keywords := TStringList.Create;
  FRowCells := TStringList.Create;
  Done := False;
  Abort := 0;
end;

destructor TAnalyzeThread.Destroy;
begin
  Keywords.Free;
  FRowCells.Free;
  inherited;
end;

procedure TAnalyzeThread.EditCell;
begin
  with frm do
  begin
    gRes.Cells[FCol, FRow] := FText;
  end;
end;

procedure TAnalyzeThread.Execute;

  function Number(s: String): Integer;
  var
    i: Integer;
  begin
    s := StringReplace(Trim(s), ',', '', [rfIgnoreCase, rfReplaceAll]);
    for i := 1 to Length(s) do
      if not (s[i] in ['0','1'..'9']) then
        s[i] := ',';
    Val(s,Result,i);
    if i <> 0 then
      Result := -1;
  end;

  function StripHTML(S: string): string;
  var
    TagBegin, TagEnd, TagLength: integer;
  begin
    TagBegin := Pos( '<', S);      // search position of first <
    while (TagBegin > 0) do begin  // while there is a < in S
      TagEnd := Pos('>', S);              // find the matching >
      TagLength := TagEnd - TagBegin + 1;
      Delete(S, TagBegin, TagLength);     // delete the tag
      TagBegin:= Pos( '<', S);            // search for next <
    end;
    Result := S;                   // give the result
  end;

var
  i, j, k, cnt, offset, iStart, iEnd, ave_cnt3, ave_sum3, ave_cnt4, ave_sum4, ave_cnt5, ave_sum5: Integer;
  s, s1, s2, url, link, title, inlinks, rank: AnsiString;
  c1, c2, c3: AnsiString;
  Doc: IHTMLDocument2;
  StartingFrom: Integer;
  url1,url2,url3:AnsiString;
  CurFileName, MessageText: String;
begin

  inherited;

  Synchronize(GetRowCount);
  StartingFrom := FRowCount;

  for i := 0 to Keywords.Count - 1 do
  begin

//    url := StringReplace(GoogleUrl, '_NUM_', Num, [rfIgnoreCase, rfReplaceAll]);
//    url := StringReplace(GoogleUrl, '_KEYWORDS_', '%22' + StringReplace(Keywords[i], ' ', '%20', [rfIgnoreCase, rfReplaceAll]) + '%22', [rfIgnoreCase, rfReplaceAll]);
    url := StringReplace(GoogleUrl, '_CX_', Trim(frm.CustomSearchEngineCode), [rfIgnoreCase, rfReplaceAll]);
    url := StringReplace(Url, '_KEY_', Trim(frm.APIKey), [rfIgnoreCase, rfReplaceAll]);
    url := StringReplace(Url, '_KEYWORDS_', StringReplace(Keywords[i], ' ', '+', [rfIgnoreCase, rfReplaceAll]), [rfIgnoreCase, rfReplaceAll]);

    url1:=url;

    try
      //GetHTMLSource(url, '', 0, 5000, 5000, s);
      s := DownloadFile3(url);
    except
    end;

//    CurFileName := 'c:\s.html';
//    SaveS(s,CurFileName);

//    ExtractParagraph(s, s1, 'id="resultStats">', '<');
    if not ExtractParagraphJSON(s, s1, '"totalResults": "', '"') then
    begin
      offset := 1;
      MessageText := 'Abnormal request terminatiom. ';
      if ExtractSParagraphJSON(s, s1, '"message": "', '"',offset) then
        MessageText := MessageText + s1;
      if i <> (Keywords.Count-1) then
        if MessageDlg(MessageText + #13#10#13#10 + 'Do you wish to continue request?',
        mtConfirmation,[mbYes,mbNo],0,mbYes)=mrYes then
          continue
        else
          exit
      else
      begin
        ShowMessage(MessageText);
        exit;
      end;
    end;
{    s2 := Copy(s1, 18, Length(s1) - 18);
    s2 := StringReplace(s2, 'About ', '', [rfReplaceAll]);
    s2 := StringReplace(s2, ' results', '', [rfReplaceAll]);
}   s2 := s1;
    c1 := s2;

    FRowCells.Clear;
    FRowCells.Add('');
    FRowCells.Add(Keywords[i]);
    FRowCells.Add('<a href="' + url1 + '">' + c1 + '</a>');
    FRowCells.Add('');
    FRowCells.Add('');
    Synchronize(AddRowA);
    FProgress := Round(100 * ((3*i+1)/(3*Keywords.Count)));
    Synchronize(UpdateProgressBar);

    Sleep(fdelay);

    //intitle:
//    url := StringReplace(GoogleUrl, '_NUM_', Num, [rfIgnoreCase, rfReplaceAll]);

    url := StringReplace(GoogleUrl, '_CX_', Trim(frm.CustomSearchEngineCode), [rfIgnoreCase, rfReplaceAll]);
    url := StringReplace(Url, '_KEY_', Trim(frm.APIKey), [rfIgnoreCase, rfReplaceAll]);
    url := StringReplace(Url, '_KEYWORDS_',
    'allintitle%3A+' +
    StringReplace(Keywords[i], ' ', '+', [rfIgnoreCase, rfReplaceAll]), [rfIgnoreCase, rfReplaceAll]);
    url2:=url;
    try
      //GetHTMLSource(url, '', 0, 15000, 15000, s);
      s := DownloadFile3(url);
    except
    end;

//    CurFileName := 'c:\s1.html';
//    SaveS(s,CurFileName);

{    ExtractParagraph(s, s1, 'id="resultStats">', '<');
    s2 := Copy(s1, 18, Length(s1) - 18);
    //ExtractParagraph(s, s1, '<div id=ires>', '</ol></div>');
    s2 := StringReplace(s2, 'About ', '', [rfReplaceAll]);
    s2 := StringReplace(s2, ' results', '', [rfReplaceAll]);
}
    if not ExtractParagraphJSON(s, s1, '"totalResults": "', '"') then
    begin
      offset := 1;
      MessageText := 'Abnormal request terminatiom. ';
      if ExtractSParagraphJSON(s, s1, '"message": "', '"',offset) then
        MessageText := MessageText + s1;
      if i <> (Keywords.Count-1) then
        if MessageDlg(MessageText + #13#10#13#10 + 'Do you wish to continue request?',
        mtConfirmation,[mbYes,mbNo],0,mbYes)=mrYes then
          continue
        else
          exit
      else
      begin
        ShowMessage(MessageText);
        exit;
      end;
    end;
    s2 := s1;
    c2 := s2;

    FRowCells.Clear;
    FRowCells.Add('<a href="' + url2 + '">' + c2 + '</a>');
    ColNum := 3;
    Synchronize(EditCol);
    FProgress := Round(100 * ((3*i+2)/(3*Keywords.Count)));
    Synchronize(UpdateProgressBar);
    Sleep(fdelay);

    //inurl:
    url := StringReplace(GoogleUrl, '_CX_', Trim(frm.CustomSearchEngineCode), [rfIgnoreCase, rfReplaceAll]);
    url := StringReplace(Url, '_KEY_', Trim(frm.APIKey), [rfIgnoreCase, rfReplaceAll]);
    url := StringReplace(Url, '_KEYWORDS_',
    'allinurl%3A+' +
    StringReplace(Keywords[i], ' ', '+', [rfIgnoreCase, rfReplaceAll]), [rfIgnoreCase, rfReplaceAll]);
    url3:=url;
    try
      //GetHTMLSource(url, '', 0, 15000, 15000, s);
      s := DownloadFile3(url);
      //saves(s);
    except
    end;

//    CurFileName := 'c:\s2.html';
//    SaveS(s,CurFileName);

{    ExtractParagraph(s, s1, 'id="resultStats">', '<');
    s2 := Copy(s1, 18, Length(s1) - 18);
    //ExtractParagraph(s, s1, '<div id=ires>', '</ol></div>');
    s2 := StringReplace(s2, 'About ', '', [rfReplaceAll]);
    s2 := StringReplace(s2, ' results', '', [rfReplaceAll]);
}
    if not ExtractParagraphJSON(s, s1, '"totalResults": "', '"') then
    begin
      offset := 1;
      MessageText := 'Abnormal request terminatiom. ';
      if ExtractSParagraphJSON(s, s1, '"message": "', '"',offset) then
        MessageText := MessageText + s1;
      if i <> (Keywords.Count-1) then
        if MessageDlg(MessageText + #13#10#13#10 + 'Do you wish to continue request?',
        mtConfirmation,[mbYes,mbNo],0,mbYes)=mrYes then
          continue
        else
          exit
      else
      begin
        ShowMessage(MessageText);
        exit;
      end;
    end;
    s2 := s1;
    c3 := s2;

    FRowCells.Clear;
    FRowCells.Add('<a href="' + url3 + '">' + c3 + '</a>');
    ColNum := 4;
    Synchronize(EditCol);
    if i <> Keywords.Count - 1 then
      Sleep(fdelay);

    FProgress := Round(100 * ((3*i+3)/(3*Keywords.Count)));
    Synchronize(UpdateProgressBar);
    if Abort <> 0 then
      Exit;
    // Goto Next Line of Keywords
    Sleep(500); // Not to overflow the WEB portal.

  end;

end;

procedure TAnalyzeThread.GetRow;
begin
  FRowCells.Clear;
  FRowCells.Add(frm.gRes.Cells[0, FRow]);
  FRowCells.Add(frm.gRes.Cells[1, FRow]);
  FRowCells.Add(frm.gRes.Cells[2, FRow]);
  FRowCells.Add(frm.gRes.Cells[3, FRow]);
  FRowCells.Add(frm.gRes.Cells[4, FRow]);
end;

procedure TAnalyzeThread.GetRowCount;
begin
  FRowCount := frm.gRes.RowCount;
end;

procedure TAnalyzeThread.UpdateProgressBar;
begin
  frm.barProgress.Position := FProgress;
end;

{$R *.dfm}

procedure Tfrm.btnStartClick(Sender: TObject);
var
  s: String;
begin
  if (Assigned(FWorker))and(not TAnalyzeThread(FWorker).Done) then
  begin
    MessageDlg('The analyzing is in progress. It must be finished first.', mtInformation, [mbOK], 0);
    Exit;
  end;
  if Trim(Memo1.Lines.Text) = '' then
  begin
    MessageDlg('Please type in some keyword phrases before search (one per line).', mtInformation, [mbOK], 0);
    Exit;
  end;
  if not CheckBox1.Checked then
  begin
    //  clear the grid
    gRes.RowCount := 2;
    gRes.Cells[0, 1] := '';
    gRes.Cells[1, 1] := '';
    gRes.Cells[2, 1] := '';
    gRes.Cells[3, 1] := '';
    gRes.Cells[4, 1] := '';
    gRes.RemoveCheckBox(0,1);
  end;
  fdelay := StrToIntDef(Edit1.Text,10) * 1000;
  if Assigned(FWorker) then
    FreeAndNil(FWorker);
  FWorker := TAnalyzeThread.Create;
  TAnalyzeThread(FWorker).Keywords.Assign(Memo1.Lines);
  TAnalyzeThread(FWorker).Num := ComboBox1.Text;
  TAnalyzeThread(FWorker).Done := False;
  TAnalyzeThread(FWorker).OnTerminate := HandleWorkerFinished;
  FWorker.Suspended := False;
  Memo1.ReadOnly := True;
  Memo1.Color := clMoneyGreen;
  barProgress.Position := 0;
end;

procedure Tfrm.btSettingsClick(Sender: TObject);
var
  SettingsResult: Integer;
begin
  SettingsResult:= FSettings.ShowModal;
  if SettingsResult = mrOk then
  begin
    APIKey := FSettings.leAPIKey.Text;
    CustomSearchEngineCode := FSettings.leCustomSearchEngineCode.Text;
  end;
  if SettingsResult = mrNo then
    CloseForm := True;
end;

procedure Tfrm.Button3Click(Sender: TObject);

  procedure btargetblank;
  var
    sl: TStringList;
  begin
    sl := TStringList.Create;
    sl.LoadFromFile(dlgs2.FileName);
    sl.Text := StringReplace(sl.Text, '<TD class="c0" nowrap>&nbsp;</td>', '', [rfReplaceAll]);
    sl.Text := StringReplace(sl.Text, '<TD class="c1" nowrap>Y</td>', '', [rfReplaceAll]);
    sl.Text := StringReplace(sl.Text, '">', '" target="_blank">', [rfReplaceAll]);
    sl.Text := StringReplace(sl.Text, '>http', ' target="_blank">http', [rfReplaceAll]);
    sl.SaveToFile(dlgs2.FileName);
  end;

begin
  if WorkersWorking(True) then
    Exit;
  Saving := True;
  if dlgS2.Execute then
  try
    gRes.SaveWithHTML := True;
    if FileExists(dlgS2.FileName) then
    begin
      if MessageDlg('The file you specified exists. Do you want to overwrite it?', mtConfirmation, [mbYes, mbCancel], 0) = ID_YES then
      begin
        gRes.SaveToHTML(dlgS2.FileName);
        btargetblank;
      end;
    end
    else
    begin
      gRes.SaveToHTML(dlgS2.FileName);
      btargetblank;
    end;
  except
  end;
  Saving := False;
end;

procedure Tfrm.TBXButton3Click(Sender: TObject);
begin
  gRes.SaveWithHTML := False;
  if (Assigned(FWorker))and(not TAnalyzeThread(FWorker).Done) then
  begin
    MessageDlg('The analyzing is in progress. It must be finished first.', mtInformation, [mbOK], 0);
    Exit;
  end;
  if dlgS.Execute then
  begin
    if FileExists(dlgS.FileName) then
    begin
      if MessageDlg('The file you specified exists. Do you want to overwrite it?', mtConfirmation, [mbYes, mbCancel], 0) = ID_YES then
        gRes.SaveToCSV(dlgS.FileName);
    end
    else
      gRes.SaveToCSV(dlgS.FileName);
  end;
end;

procedure Tfrm.TBXButton4Click(Sender: TObject);
var
  i: Integer;
begin
  if (Assigned(FWorker))and(not TAnalyzeThread(FWorker).Done) then
  begin
    MessageDlg('The analyzing is in progress. It must be finished first.', mtInformation, [mbOK], 0);
    Exit;
  end;
  if dlgO.Execute then
  try
    //  clear the grid
    gRes.RowCount := 2;
    gRes.Cells[0, 1] := '';
    gRes.Cells[1, 1] := '';
    gRes.Cells[2, 1] := '';
    gRes.Cells[3, 1] := '';
    gRes.Cells[4, 1] := '';
    gRes.RemoveCheckBox(0,1);
    gRes.ColWidths[1] := 160;
    gRes.ColWidths[2] := 160;
    //
    gRes.LoadFromCSV(dlgO.FileName);
    {for i := 1 to gRes.RowCount-1 do
    begin
      if Trim(gRes.Cells[0,i]) = '' then
      begin
        if Pos('results',gRes.Cells[2,i])>0 then
        begin
          gRes.Cells[1,i] := '<b>'+gRes.Cells[1,i]+'</b>';
          gRes.Cells[2,i] := '<b>'+gRes.Cells[2,i]+'</b>';
        end;
        if Pos('Averages:',gRes.Cells[2,i])>0 then
        begin
          gRes.Cells[2,i] := '<b>'+gRes.Cells[2,i]+'</b>';
          if trim(gRes.Cells[3,i]) <> '' then
            gRes.Cells[3,i] := '<b>'+gRes.Cells[3,i]+'</b>';
          if trim(gRes.Cells[4,i]) <> '' then
            gRes.Cells[4,i] := '<b>'+gRes.Cells[4,i]+'</b>';
          if trim(gRes.Cells[5,i]) <> '' then
            gRes.Cells[5,i] := '<b>'+gRes.Cells[5,i]+'</b>';
        end;
      end;
    end;}
    CheckBox2Click(nil);
  except
  end;
end;

function Tfrm.WorkersWorking(ARaiseAlarm: Boolean): Boolean;
begin
  Result := False;
  if (Assigned(FWorker))and(not TAnalyzeThread(FWorker).Done) then
  begin
    Result := True;
  end;
  if Result and ARaiseAlarm then
  begin
    MessageDlg('Searching in progress. Stop the search first or wait for it to finish.', mtInformation, [mbOK], 0);
  end;
end;

procedure Tfrm.bClearAllClick(Sender: TObject);
var
  cnt: Integer;
begin
  if WorkersWorking(True) then
    Exit;
  { FIX: Added code for row deletion }
  gRes.BeginUpdate;
  try
    If MessageDlg('Delete checked row(s)?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
      For Cnt := gRes.RowCount - 1 downto 1 do
      begin
        If gRes.IsChecked(0,Cnt) then
          gRes.RemoveRows(Cnt, 1);
      end;
    end;
  finally
    gRes.EndUpdate;
  end;
  if gRes.RowCount = 1 then
    gRes.RowCount := 2
  else
  begin
    for Cnt := 1 to gRes.RowCount - 1 do
      gRes.Cells[0,Cnt] := IntToStr(Cnt);
  end;
end;

procedure Tfrm.bClearClick(Sender: TObject);
begin
  if WorkersWorking(True) then
    Exit;
  if MessageDlg('Clear all rows?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    gRes.RowCount := 2;
    gRes.Cells[0,1] := '';
    gRes.Cells[1,1] := '';
    gRes.Cells[2,1] := '';
    gRes.Cells[3,1] := '';
    gRes.Cells[4,1] := '';
    gRes.RemoveCheckBox(0,1);
    Memo1.Clear;
  end;
end;

procedure Tfrm.bExportClick(Sender: TObject);

  procedure btargetblank;
  var
    sl: TStringList;
    i: Integer;
  begin
    sl := TStringList.Create;
    sl.LoadFromFile(dlgs.FileName);
    sl[0] := Copy(sl[0], 2, MaxInt);
    for i := 0 to sl.Count - 1 do
      sl[i] := Copy(sl[i], 3, MaxInt);
    sl.SaveToFile(dlgs.FileName);
  end;

begin
  if WorkersWorking(True) then
    Exit;
  Saving := True;
  if dlgS.Execute then
  try
    gRes.SaveWithHTML := False;
    if FileExists(dlgS.FileName) then
    begin
      if MessageDlg('The file you specified exists. Do you want to overwrite it?', mtConfirmation, [mbYes, mbCancel], 0) = ID_YES then
      begin
        gRes.SaveToCSV(dlgS.FileName);
        btargetblank;
      end;
    end
    else
    begin
      gRes.SaveToCSV(dlgS.FileName);
      btargetblank;
    end;
  except
  end;
  Saving := False;
end;

procedure Tfrm.bOpenClick(Sender: TObject);
var
  i: Integer;
begin
  if WorkersWorking(True) then
    Exit;
  if dlgO.Execute then
  begin
    gRes.LoadFromCSV(dlgO.FileName);
    for i := 1 to gRes.RowCount - 1 do
      if gRes.Cells[1,i] <> '' then
        gRes.AddCheckBox(0, i, True, False);
  end;
end;

procedure Tfrm.bSaveClick(Sender: TObject);
begin
  if WorkersWorking(True) then
    Exit;
  Saving := True;
  if dlgS.Execute then
  try
    gRes.SaveWithHTML := True;
    if FileExists(dlgS.FileName) then
    begin
      if MessageDlg('The file you specified exists. Do you want to overwrite it?', mtConfirmation, [mbYes, mbCancel], 0) = ID_YES then
        gRes.SaveToCSV(dlgS.FileName);
    end
    else
      gRes.SaveToCSV(dlgS.FileName);
  except
  end;
  Saving := False;
end;

procedure Tfrm.bStopClick(Sender: TObject);
begin
 if Assigned(FWorker) then
   TAnalyzeThread(FWorker).Abort := 1;
end;

procedure Tfrm.HandleWorkerFinished(Sender: TObject);
begin
  TAnalyzeThread(FWorker).Done := True;
  Memo1.ReadOnly := False;
  Memo1.Color := clWindow;
  barProgress.Position := 0;
  if FileExists(GetTempFolder + 'chimes.wav') then
  begin
    MediaPlayer1.FileName := GetTempFolder + 'chimes.wav';
    MediaPlayer1.Open;
    MediaPlayer1.Play;
  end;
end;

procedure Tfrm.TBXButton2Click(Sender: TObject);
begin
  Close;
end;

procedure Tfrm.FormActivate(Sender: TObject);
begin
  if CloseForm then
    application.Terminate;
end;

procedure Tfrm.FormClose(Sender: TObject; var Action: TCloseAction);
var
  Regist: TRegistry;
begin
  Regist := TRegistry.Create;
  Regist.RootKey := HKEY_CURRENT_USER;
  Regist.OpenKey('Software\XyberCode\EasySEONinja\Settings', True);
// Settings
  Regist.WriteString('APIkey', APIKey);
  Regist.WriteString('Engine Code', CustomSearchEngineCode);
  Regist.CloseKey;
  if Regist <> nil then
    Regist.Free();
end;

procedure Tfrm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if (Assigned(FWorker))and(not TAnalyzeThread(FWorker).Done) then
  begin
    MessageDlg('The analyzing is in progress. It must be finished first.', mtInformation, [mbOK], 0);
    CanClose := False;
  end;
end;

procedure Tfrm.TBXButton1Click(Sender: TObject);

var
  i: Integer;
  s: AnsiString;

  procedure getS;
  var
    i: Integer;
  begin
    s := '';
    for i := 1 to gRes.RowCount - 1 do
      if gRes.IsChecked(0,i) then
      begin
        if s = '' then
          s := gRes.Cells[1,i]
        else
          s := s + #13#10 + gRes.Cells[1,i];
      end;
  end;

begin
  if (Assigned(FWorker))and(not TAnalyzeThread(FWorker).Done) then
  begin
    MessageDlg('The analyzing is in progress. It must be finished first.', mtInformation, [mbOK], 0);
    Exit;
  end;
  GetS;
  if trim(s) = '' then
  begin
    MessageDlg('Please check some of the keywords first.', mtInformation, [mbOK], 0);
    Exit;
  end;
  frmDeepAnalysis.Memo1.Text := s;
  frmDeepAnalysis.ClearGrid;
  frmDeepAnalysis.Showmodal;
end;

procedure Tfrm.TBXButton5Click(Sender: TObject);
var
  s: AnsiString;
  stream: TResourceStream;
begin
{  s := GetTempFolder + 'Simple SEO Tactics.pdf';
  stream := TResourceStream.Create(HInstance, PChar('pdf'), PChar('DATA'));
  stream.SaveToFile(s);
  ShellExecute(0, PChar('open'), PChar(s), nil, nil, SW_SHOW);  }
  ShellExecute(0, PChar('open'), PChar('http://www.backlinksninja.com/2000-bonus-backlinks.php'), nil, nil, SW_SHOW);
end;

procedure Tfrm.Timer1Timer(Sender: TObject);
begin
//  Panel2.Visible := (Assigned(FWorker))and(not TAnalyzeThread(FWorker).Done);
end;

procedure Tfrm.CheckBox2Click(Sender: TObject);
var
  i, j, space: Integer;
begin
  if (CheckBox2.Checked)and(gRes.RowCount > 2) then
  begin
    frm.gRes.SizeGrowOnly := True;
    frm.gRes.AutoSizeCol(1);
    frm.gRes.AutoSizeCol(2);
    space := gRes.Width-24;
    j := 0;
    for i := 0 to gRes.ColCount-1 do
      j := j + gRes.ColWidths[i];
    if j > space then
    begin
      i := (j-space) div 2;
      //gRes.ColWidths[1] := gRes.ColWidths[1] - i;
      gRes.ColWidths[2] := gRes.ColWidths[2] - 2*i;
    end;
  end;
end;

procedure Tfrm.FormCreate(Sender: TObject);
var
  s: AnsiString;
  stream: TResourceStream;
  Regist: TRegistry;
  from_reg : Boolean;
begin
  s := GetTempFolder + 'chimes.wav';
  stream := TResourceStream.Create(HInstance, PChar('chimes'), PChar('DATA'));
  stream.SaveToFile(s);
// Get parameters
  Regist := TRegistry.Create;
  Regist.RootKey := HKEY_CURRENT_USER;
  from_reg := Regist.OpenKey('Software\XyberCode\EasySEONinja\Settings', False);
  if from_reg then
  begin
    APIKey := Regist.ReadString('APIkey');
    CustomSearchEngineCode := Regist.ReadString('Engine Code');
  end
  else
  begin
    APIKey := '';
    CustomSearchEngineCode := '';
  end;
  Regist.CloseKey;
  if Regist <> nil then
    Regist.Free();
end;

procedure Tfrm.FormShow(Sender: TObject);
begin
  if (APIKey='') or (CustomSearchEngineCode='') then
    while ((APIKey='') or (CustomSearchEngineCode='')) and not CloseForm do
      btSettingsClick(nil);
end;

procedure Tfrm.gResGetCellColor(Sender: TObject; ARow, ACol: Integer;
  AState: TGridDrawState; ABrush: TBrush; AFont: TFont);

  function StripHTML(S: string): string;
  var
    TagBegin, TagEnd, TagLength: integer;
  begin
    TagBegin := Pos( '<', S);      // search position of first <
    while (TagBegin > 0) do begin  // while there is a < in S
      TagEnd := Pos('>', S);              // find the matching >
      TagLength := TagEnd - TagBegin + 1;
      Delete(S, TagBegin, TagLength);     // delete the tag
      TagBegin:= Pos( '<', S);            // search for next <
    end;
    Result := S;                   // give the result
  end;


var
  i: Int64;
begin
  if trim(gRes.Cells[ACol,ARow]) = '' then
    Exit;
  if ARow > 0 then
  begin
    if ACol = 2 then
    begin
      i := stoi(StripHTML(gRes.GridCells[ACol,ARow]));
      if i < 200000 then
        ABrush.Color := clLime
      else if i < 600000 then
        ABrush.Color := clYellow
      else
        ABrush.Color := 3947775;//5992179;//clRed;
    end;
    if ACol = 3 then
    begin
      i := stoi(StripHTML(gRes.GridCells[ACol,ARow]));
      if i < 10000 then
        ABrush.Color := clLime
      else if i < 50000 then
        ABrush.Color := clYellow
      else
        ABrush.Color := 3947775;//5992179;//clRed;
    end;
    if ACol = 4 then
    begin
      i := stoi(StripHTML(gRes.GridCells[ACol,ARow]));
      if i < 10000 then
        ABrush.Color := clLime
      else if i < 50000 then
        ABrush.Color := clYellow
      else
        ABrush.Color := 3947775;//5992179;//clRed;
    end;
  end;
end;

initialization

  FmtSettings.DecimalSeparator := '.';
  FmtSettings.ThousandSeparator := ',';

end.
