
[Setup]
AppName=Easy SEO Ninja
AppVerName=Easy SEO Ninja 1.3
DefaultDirName={pf}\Easy SEO Ninja
; Since no icons will be created in "{group}", we don't need the wizard
; to ask for a Start Menu folder name:
DisableProgramGroupPage=yes
UninstallDisplayIcon={app}\EasySEONinja.exe


[Files]
Source: "EasySEONinja.exe"; DestDir: "{app}"

[Registry]
Root: HKCU; Subkey: "Software\XyberCode"; Flags: uninsdeletekeyifempty
Root: HKCU; Subkey: "Software\XyberCode\EasySEONinja"; Flags: uninsdeletekey
Root: HKCU; Subkey: "Software\XyberCode\EasySEONinja\Settings"; ValueType: string; ValueName: "Engine Code"; ValueData: "{code:GetUser|Custom Search Engine Code}"
Root: HKCU; Subkey: "Software\XyberCode\EasySEONinja\Settings"; ValueType: string; ValueName: "APIkey"; ValueData: "{code:GetUser|API Key}"



[Icons]
Name: "{commonprograms}\Easy SEO Ninja\Easy SEO Ninja"; Filename: "{app}\EasySEONinja.exe"
Name: "{commonprograms}\Easy SEO Ninja\Uninstall Easy SEO Ninja"; Filename: "{app}\unins000.exe"
Name: "{commondesktop}\Easy SEO Ninja"; Filename: "{app}\EasySEONinja.exe"

[Code]
var
  UserPage: TInputQueryWizardPage;
  
procedure InitializeWizard;
begin
  { Create the pages }
  
  UserPage := CreateInputQueryPage(wpWelcome,
    'Google Search API Information', '','If you have already registered your Google search engine,'#13#10 +
    'enter the value of Search Engine Code and API key.'#13#10 +
    'You can skip this form and do it later when you start the program.');
  UserPage.Add('Custom Search Engine Code:', False);
  UserPage.Add('API Key:', False);
 

  { Set default values, using settings that were stored last time if possible }

  UserPage.Values[0] := '';
  UserPage.Values[1] := '';
end;

function GetUser(Param: String): String;
begin
  { Return a user value }
  { Could also be split into separate GetUserName and GetUserCompany functions }
  if Param = 'Custom Search Engine Code' then
    Result := UserPage.Values[0]
  else if Param = 'API Key' then
    Result := UserPage.Values[1];
end;
