unit uTrackKeywords;

interface

uses
  Forms, SysUtils, Classes, ComCtrls, ExtCtrls, DB, ADODB, Dialogs, StdCtrls, myListView, FastStringFuncs;

type
  PKey = ^TKey;
  TKey = record
    ID:         integer;
    profile_id: integer;
    keyword:    string;
    url:        string;
  end;

function CheckDuplicateKeyword(l: TList; k: PKey):boolean;
function AddNewKeyword(k: PKey):integer;
function AddNewKeywordData(k_id: integer; k_engine: string; k_position, k_backlinks: longint):integer;
function RemoveKeyword(k: PKey):integer;
function LoadKeys(pid: integer; var tl: TList):integer;
function PopulateKeysList(tl: TList; var lv: TMyListView):integer;
function ClearKeysList(var tl: TList):integer;
function SaveKeyword(k: PKey):integer;
function GetPositionInGoole(engine_url, checkurl, keyword: string):integer;
function GetPositionInYahoo(engine_url, checkurl, keyword: string):integer;
function GetPositionInMSN(engine_url, checkurl, keyword: string):integer;
function GetPositionInBING(engine_url, checkurl, keyword: string):integer;
function GetGoogleUrlForPosition:string;
function GetYahooUrlForPosition:string;
function GetMSNUrlForPosition:string;
function GetGoogleBacklinks(url: string):longint;
function GetYahooBacklinks(url: string):longint;
function GetMSNBacklinks(url: string):longint;


implementation

uses uHelper, FastStrings;

//
// function to get the results from Google
//
procedure GoogleGetResults(url: string; var sl: TStringList);
var
  s, t:   string;
  title:  string;
  stop:   boolean;

  //tl: TStringList;
begin
  //Say('*** url = ' + url);
  s := DownloadFile3(url);

  {
  tl := TStringList.create;
  tl.Text := s;
  tl.SaveToFile('google-out.html');
  tl.Clear;
  tl.Free;
  }

  RemoveHead(s);
  stop := true;
  repeat
    stop := ExtractParagraph(s, t, '<h2 class=r>', '</h2>');
    //Say('G paragraph: ' + t);
    if (Trim(t) <> '') then
    begin
      t := ExtractLink(t, 'href="', '" class');
      sl.Add(t);
      // Say('--- G link: ' + t);
    end;
  until not stop;
end;

//
// function to get the results from Yahoo
//
procedure YahooGetResults(url: string; var sl: TStringList);
var
  s, t:   string;
  stop:   boolean;
begin
  //Say('>>> Y! url = ' + url);
  s := DownloadFile3(url);
  RemoveHead(s);
  repeat
    stop := ExtractParagraph(s, t, '<a class="yschttl spt', '</a>', '');
    //Say('-- section: ' + t);

    if (Trim(t) <> '') then
    begin
      t := ExtractLink(t, '**http%3a', '"');
      t := 'http:' + t;
      sl.Add(t);
    end;
  until not stop;
end;

//
//  function to get results from MSN
//
procedure MSNGetResults(url: string; var sl: TStringList);
var
  s, t:   string;
  title:  string;
  stop:   boolean;
begin
  s := DownloadFile3(url);
  RemoveHead(s);
  stop := true;
  repeat
    stop := ExtractParagraph(s, t, '<h3><a href="', '</h3>');
    if (Trim(t) <> '') then
    begin
      t := ExtractLink(t, 'href="', '" gping="');
      sl.Add(t);
    end;
  until not stop;
end;

//
//  function to get results from MSN
//
procedure BINGGetResults(url: string; var sl: TStringList);
var
  s, t:   string;
  title:  string;
  stop:   boolean;
begin
  s := DownloadFile3(url);
  RemoveHead(s);
  stop := true;
  repeat
    //stop := ExtractParagraph(s, t, '<h3><a href="', '</h3>');
    stop := ExtractParagraph(s, t, 'sb_tlst', '</h3>');
    if (Trim(t) <> '') then
    begin
      t := ExtractLink(t, 'href="', '"');
      sl.Add(t);
    end;
  until not stop;
end;

//
//
//
function GetGoogleUrlForPosition:string;
var
  table:  TADOTable;
begin
  table := TADOTable.Create(nil);
  // get the url
  with table do
  begin
    ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=' + GetDBFileName() + ';Persist Security Info=False';
    TableName := 'engines';
    Active := True;
    Filter := 'engine_name = ' + QuotedStr('google');
    Filtered := True;
    First;

    if Locate('engine_setting', 'position_url', [loCaseInsensitive]) then
      Result := FieldByName('engine_value').AsString
    else
      Exit;
    Filter := '';
    Filtered := True;
    Filtered := False;
    Close;
    Active := False;
  end;
  table.Free;
end;

//
//
//
function GetYahooUrlForPosition:string;
var
  table:  TADOTable;
begin
  table := TADOTable.Create(nil);
  // get the url
  with table do
  begin
    ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=' + GetDBFileName() + ';Persist Security Info=False';
    TableName := 'engines';
    Active := True;
    Filter := 'engine_name = ' + QuotedStr('yahoo');
    Filtered := True;
    First;

    if Locate('engine_setting', 'position_url', [loCaseInsensitive]) then
      Result := FieldByName('engine_value').AsString
    else
      Exit;
    Filter := '';
    Filtered := True;
    Filtered := False;
    Close;
    Active := False;
  end;
  table.Free;
end;

//
//
//
function GetMSNUrlForPosition:string;
var
  table:  TADOTable;
begin
  table := TADOTable.Create(nil);
  // get the url
  with table do
  begin
    ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=' + GetDBFileName() + ';Persist Security Info=False';
    TableName := 'engines';
    Active := True;
    Filter := 'engine_name = ' + QuotedStr('msn');
    Filtered := True;
    First;

    if Locate('engine_setting', 'position_url', [loCaseInsensitive]) then
      Result := FieldByName('engine_value').AsString
    else
      Exit;
    Filter := '';
    Filtered := True;
    Filtered := False;
    Close;
    Active := False;
  end;
  table.Free;
end;

//
// function to get position in Google
//
function GetPositionInGoole(engine_url, checkurl, keyword: string):integer;
var
  tmp:    string;
  url:    string;
  start:  integer;
  found:  boolean;
  poz:    integer;
  sl:     TStringList;
  i:      integer;
  t:      string;
begin
  tmp := engine_url;

  t := Trim(keyword);
  while (Pos(' ', t) > 0) do
    t := FastAnsiReplace(t, ' ', '+', [rfIgnoreCase]);

  sl := TStringList.Create;
  url   := FastAnsiReplace(tmp, 'MY_SEARCH_TERM', t, [rfIgnoreCase]);
  tmp   := url;
  start := 0;
  found := false;
  poz   := 0;
  while (not found) and (start < 100) do
  begin
    url := FastAnsiReplace(tmp, 'MY_START_NUM', IntToStr(start), [rfIgnoreCase]);
    url := FastAnsiReplace(url, 'MY_NUM_PER_PAGE', '100', [rfIgnoreCase]);

    sl.Clear;
    GoogleGetResults(url, sl);

    if sl.Count = 0 then
    begin
      poz := 0;
      found := true;
      break;
    end;

    for i := 0 to sl.Count - 1 do
    begin
      if (Pos(ExtractDomain(checkurl), sl[i]) > 0) then
      begin
        poz := start + i + 1;
        found := true;
        break;
      end;
    end;

    start := start + 100;
    Sleep(1000 + Random(1000));
    Application.ProcessMessages;
  end;

  sl.Clear;
  sl.Free;
  Result := poz;
end;

//
// function to get position in Yahoo
//
function GetPositionInYahoo(engine_url, checkurl, keyword: string):integer;
var
  tmp:    string;
  url:    string;
  start:  integer;
  found:  boolean;
  poz:    integer;
  sl:     TStringList;
  i:      integer;
begin
  tmp := engine_url;

  sl    := TStringList.Create;
  url   := FastAnsiReplace(tmp, 'MY_SEARCH_TERM', keyword, [rfIgnoreCase]);
  tmp   := url;
  start := 0;
  found := false;
  poz   := 0;
  while (not found) and (start < 100) do
  begin
    url := FastAnsiReplace(tmp, 'MY_START_NUM', IntToStr(start), [rfIgnoreCase]);
    url := FastAnsiReplace(url, 'MY_NUM_PER_PAGE', '100', [rfIgnoreCase]);

    sl.Clear;
    YahooGetResults(url, sl);

    if sl.Count = 0 then
    begin
      poz   := 0;
      found := true;
      break;
    end;

    for i := 0 to sl.Count - 1 do
    begin
      //if (Pos(ExtractDomain(checkurl), sl[i]) > 0) then
      if LowerCase(Trim(checkurl)) = LowerCase(Trim(sl[i])) then
      begin
        poz := start + i + 1;
        found := true;
        break;
      end;
    end;

    start := start + 100;
    Sleep(1000 + Random(1000));
    Application.ProcessMessages;
  end;

  sl.Clear;
  sl.Free;
  Result := poz;
end;

//
// function to get position in MSN
//
function GetPositionInMSN(engine_url, checkurl, keyword: string):integer;
var
  tmp:    string;
  url:    string;
  start:  integer;
  found:  boolean;
  poz:    integer;
  sl:     TStringList;
  i:      integer;
begin
  tmp := engine_url;
  
  sl := TStringList.Create;
  url   := FastAnsiReplace(tmp, 'MY_SEARCH_TERM', keyword, [rfIgnoreCase]);
  tmp   := url;
  start := 0;
  found := false;
  poz   := 0;
  while (not found) and (start < 100) do
  begin
    url := FastAnsiReplace(tmp, 'MY_START_NUM', IntToStr(start), [rfIgnoreCase]);
    url := FastAnsiReplace(url, 'MY_NUM_PER_PAGE', '100', [rfIgnoreCase]);

    sl.Clear;
    MSNGetResults(url, sl);

    if sl.Count = 0 then
    begin
      poz := 0;
      found := true;
      break;
    end;

    for i := 0 to sl.Count - 1 do
    begin
      if (Pos(ExtractDomain(checkurl), sl[i]) > 0) then
      begin
        poz := start + i + 1;
        found := true;
        break;
      end;
    end;

    start := start + 100;
    Sleep(1000 + Random(1000));
    Application.ProcessMessages;
  end;

  sl.Clear;
  sl.Free;
  Result := poz;
end;

//
// function to get position in BING
//
function GetPositionInBING(engine_url, checkurl, keyword: string):integer;
var
  tmp:    string;
  url:    string;
  start:  integer;
  found:  boolean;
  poz:    integer;
  sl:     TStringList;
  i:      integer;
begin
  tmp := engine_url;

  sl := TStringList.Create;
  url   := FastAnsiReplace(tmp, 'MY_SEARCH_TERM', keyword, [rfIgnoreCase]);
  tmp   := url;
  start := 1;
  found := false;
  poz   := 0;
  while (not found) and (start < 100) do
  begin
    url := FastAnsiReplace(tmp, 'MY_START_NUM', IntToStr(start), [rfIgnoreCase]);
    url := FastAnsiReplace(url, 'MY_NUM_PER_PAGE', '100', [rfIgnoreCase]);

    sl.Clear;
    BINGGetResults(url, sl);

    if sl.Count = 0 then
    begin
      poz := 0;
      found := true;
      break;
    end;

    for i := 0 to sl.Count - 1 do
    begin
      //if (Pos(ExtractDomain(checkurl), sl[i]) > 0) then
      if LowerCase(Trim(checkurl)) = LowerCase(Trim(sl[i])) then
      begin
        poz := start + i;
        found := true;
        break;
      end;
    end;

    start := start + sl.Count;
    tmp := 'http://www.bing.com/search?q=google&first=MY_START_NUM';
    Sleep(1000 + Random(1000));
    Application.ProcessMessages;
  end;

  sl.Clear;
  sl.Free;
  Result := poz;
end;

//
// function to check if we have the keyword already
//
function CheckDuplicateKeyword(l: TList; k: PKey):boolean;
var
  e:  PKey;
  i:  integer;
begin
  Result := False;
  for i := 0 to l.Count - 1 do
  begin
    e := l.Items[i];
    if (e.keyword = k.keyword) and (e.url = k.url) then
    begin
      Result := True;
      Break;
    end;
  end;
end;

//
// function to add a new keyword to the database
//
function AddNewKeyword(k: PKey):integer;
var
  table:  TADOTable;
begin
  table := TADOTable.Create(nil);
  with table do
  begin
    ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=' + GetDBFileName() + ';Persist Security Info=False';
    TableName := 'keywords';
    Active := True;
    Insert;

    FieldByName('profile_id').Value := k.profile_id;
    FieldByName('keyword').Value    := k.keyword;
    FieldByName('url').Value        := k.url;

    Post;
    Refresh;
    Close;
    Active := False;

    Result := 1;
  end;
  table.Free;
end;

//
// function to remove a keyword from the database
//
function RemoveKeyword(k: PKey):integer;
var
  table:  TADOTable;
begin
  table := TADOTable.Create(nil);
  with table do
  begin
    ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=' + GetDBFileName() + ';Persist Security Info=False';
    TableName := 'keywords';
    Active := True;

    if (Locate('ID', k.ID, [])) then Delete;

    Refresh;
    Close;
    Active := False;

    TableName := 'keyword_data';
    Active := True;
    First;

    while (Locate('keyword_id', k.ID, [])) do Delete;

    Refresh;
    Close;
    Active := False;

    Result := 1;
  end;
  table.Free;
end;

//
// load keywords from a database into a list
//
function LoadKeys(pid: integer; var tl: TList):integer;
var
  k: PKey;
  table:  TADOTable;
begin
  table := TADOTable.Create(nil);
  Result := 0;

  with table do
  begin
    ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=' + GetDBFileName() + ';Persist Security Info=False';
    TableName := 'keywords';
    Active := True;

    Filter := 'profile_id = ' + QuotedStr(IntToStr(pid));
    Filtered := True;
    First;

    while not EOF do
    begin
      k := New(PKey);
      k.ID            := FieldByName('ID').AsInteger;
      k.profile_id    := FieldByName('profile_id').AsInteger;
      k.keyword       := FieldByName('keyword').AsString;
      k.url           := FieldByName('url').AsString;

      tl.Add(k);
      Result := Result + 1;
      Next;
    end;

    // make sure the table is not filtered anymore
    Filter := '';
    Filtered := True;
    Filtered := False;
    Close;
    Active := False;
  end;
  table.Free;
end;

//
// populate the keywords view with data from the list
//
function PopulateKeysList(tl: TList; var lv: TMyListView):integer;
var
  k:  PKey;
  i:  integer;
  li: TListItem;
begin
  Result := 0;
  if (tl.Count <= 0) then Exit;

  lv.Items.Clear;

  i := 0;
  while (i < tl.Count) do
  begin
    k := tl.Items[i];
    li := lv.Items.Add;
    li.Caption := k.keyword;
    li.SubItems.Add(k.url);
    i := i + 1;
  end;
end;

//
// clear the list disposing the data to avoid memory leaks
//
function ClearKeysList(var tl: TList):integer;
var
  k: PKey;
begin
  Result := 0;
  while (tl.Count > 0) do
  begin
    k := tl.Items[0];
    Dispose(k);
    tl.Delete(0);
    Result := Result + 1;
  end;
end;

function SaveKeyword(k: PKey):integer;
var
  table:  TADOTable;
begin
  table := TADOTable.Create(nil);
  with table do
  begin
    ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=' + GetDBFileName() + ';Persist Security Info=False';
    TableName := 'keywords';
    Active := True;

    if (Locate('ID', k.ID, [])) then
    begin
      Edit;
      FieldByName('profile_id').Value := k.profile_id;
      FieldByName('keyword').Value    := k.keyword;
      FieldByName('url').Value        := k.url;
      Post;
    end;

    Refresh;
    Close;
    Active := False;

    Result := 1;
  end;
  table.Free;
end;

function GetGoogleBacklinks(url: string):longint;
var
  e_url:  string;
  page:   string;
begin
  Result := 0;
  e_url := 'http://www.google.com/search?hl=en&q=link%3a' + url;
  // Say('>>>>>>>>>>>>> ' + e_url);
  page := DownloadFile3(e_url);
  RemoveHead(page);

  if Pos('<font size=-1>Results', page) > 0 then
  begin
    Delete(page, 1, Pos('<font size=-1>Results', page) + 21);
    if Pos('linking to <b>', page) > 0 then
    begin
      Delete(page, Pos('linking to <b>', page), Length(page));
      if Pos('of about', page) > 0 then
      begin
        Delete(page, 1, Pos('of about', page) + 8);
        page := Trim(ExtractNONHtml(page));
        page := StringReplace(page, ',', '', [rfReplaceAll]);
        page := StringReplace(page, '.', '', [rfReplaceAll]);
        page := StringReplace(page, ' ', '', [rfReplaceAll]);
        try
          Result := StrToInt(page);
        except
        end;
      end
      else
      begin
        if Pos('of', page) > 0 then
        begin
          Delete(page, 1, Pos('of', page) + 2);
          page := Trim(ExtractNONHtml(page));
          page := StringReplace(page, ',', '', [rfReplaceAll]);
          page := StringReplace(page, '.', '', [rfReplaceAll]);
          page := StringReplace(page, ' ', '', [rfReplaceAll]);
          try
            Result := StrToInt(page);
          except
          end;
        end;
      end;
    end;
  end;
end;

function GetYahooBacklinks(url: string):longint;
var
  e_url:  string;
  page:   string;
begin
  Result := 0;
  e_url := 'http://search.yahoo.com/search?p=link%3a' + url;
  //Say('>>>>>>>>>>>>> ' + e_url);
  page := DownloadFile3(e_url);
  RemoveHead(page);

  if Pos('Inlinks', page) > 0 then
  begin
    Delete(page, 1, Pos('Inlinks', page) + 7);
    if Pos('</p></div>', page) > 0 then
    begin
      Delete(page, Pos('</p></div>', page), Length(page));
      //Say('---02. ' + page);
      if Pos('of about', page) > 0 then
      begin
        Delete(page, 1, Pos('of about', page) + 8);
        //Say('---03. ' + page);
        if Pos('</strong>', page) > 0 then
        begin
          Delete(page, Pos('</strong>', page), Length(page));
          page := Trim(ExtractNONHtml(page));
          page := StringReplace(page, ',', '', [rfReplaceAll]);
          page := StringReplace(page, '.', '', [rfReplaceAll]);
          page := StringReplace(page, ' ', '', [rfReplaceAll]);
          //Say('---04. ' + page);
          try
            Result := StrToInt(page);
          except
          end;
        end;
      end
      else
      begin
        if Pos('of', page) > 0 then
        begin
          Delete(page, 1, Pos('of', page) + 2);
          //Say('---03. ' + page);
          if Pos('</strong>', page) > 0 then
          begin
            Delete(page, Pos('</strong>', page), Length(page));
            page := Trim(ExtractNONHtml(page));
            page := StringReplace(page, ',', '', [rfReplaceAll]);
            page := StringReplace(page, '.', '', [rfReplaceAll]);
            page := StringReplace(page, ' ', '', [rfReplaceAll]);
            //Say('---04. ' + page);
            try
              Result := StrToInt(page);
            except
            end;
          end;
        end;
      end;
    end;
  end;
end;

function GetMSNBacklinks(url: string):longint;
var
  e_url:  string;
  page:   string;
begin
  Result := 0;
  e_url := 'http://alltheweb.com/search?cat=web&cs=utf8&q=link%3A' + url + '&rys=0&itag=crv&_sb_lang=pref';
  //Say('>>>>>>>>>>>>> ' + e_url);
  page := DownloadFile3(e_url);
  RemoveHead(page);

  if Pos('<span class="ofSoMany">', page) > 0 then
  begin
    Delete(page, 1, Pos('<span class="ofSoMany">', page) + 21);
    if Pos('</span>', page) > 0 then
    begin
      Delete(page, Pos('</span>', page), Length(page));
      page := Trim(ExtractNONHtml(page));
      page := StringReplace(page, ',', '', [rfReplaceAll]);
      page := StringReplace(page, '.', '', [rfReplaceAll]);
      page := StringReplace(page, ' ', '', [rfReplaceAll]);
      try
        Result := StrToInt(page);
      except
      end;
    end;
  end;
end;

//
// function to add new data for a keyword
//
function AddNewKeywordData(k_id: integer; k_engine: string; k_position, k_backlinks: longint):integer;
var
  table:  TADOTable;
begin
  table := TADOTable.Create(nil);
  with table do
  begin
    ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=' + GetDBFileName() + ';Persist Security Info=False';
    TableName := 'keyword_data';
    Active := True;
    Insert;

    FieldByName('keyword_id').Value   := k_id;
    FieldByName('engine_name').Value  := k_engine;
    FieldByName('date').Value         := Now();
    FieldByName('position').Value     := k_position;
    FieldByName('backlinks').Value    := k_backlinks;

    Post;
    Refresh;
    Close;
    Active := False;

    Result := 1;
  end;
  table.Free;
end;

end.
